import type { Plugin } from 'vite'
import path from 'path'

// https://github.com/antfu/unplugin-auto-import
import AutoImport from 'unplugin-auto-import/vite'

/**
 * unplugin-auto-import
 * @returns Plugin
 */
export function configAutoImportPlugin(): Plugin {
    return AutoImport({
        dts: 'types/auto-imports.d.ts',
        imports: [
            'vue',
            'vue-i18n',
            'uni-app',
            {
                '@/config/app': ['$app'],
                '@/api/services': ['defs'],
                '@/api/services/mods': ['API'],
                '@/common/message': ['Message'],
            },
        ],
        resolvers: [
            (name) => {
                // FIX: 修复 easycom 在 APP 下不生效问题
                if (name.startsWith('fui-')) {
                    return path.resolve(__dirname, `src/components/firstui/${name}/${name}.vue`).replaceAll('\\', '/')
                }
            },
        ],
    })
}
